diff --git a/lib/hive/daemon/auto_retry/state.rb b/lib/hive/daemon/auto_retry/state.rb
new file mode 100644
index 00000000..eca8e788
--- /dev/null
+++ b/lib/hive/daemon/auto_retry/state.rb
@@ -0,0 +1,307 @@
+# frozen_string_literal: true
+
+require "json"
+require "fileutils"
+require "time"
+require "hive/paths"
+require "hive/daemon/auto_retry/policy"
+
+module Hive
+  module Daemon
+    module AutoRetry
+      # Durable retry ledger under state_home. Keyed by project identity,
+      # task id (slug fallback), stage, and marker reason — NOT marker_id.
+      # Fail-closed: corrupt/unreadable/newer-schema/unwritable state
+      # suspends automatic mutation rather than resetting budgets.
+      class State
+        SCHEMA_VERSION = 1
+        STALE_TMP_SEC = 60
+        FILENAME = "daemon_auto_retry.json"
+
+        PHASES = %w[
+          candidate clear_queued marker_cleared retry_queued retry_dispatched
+          failed succeeded aborted exhausted
+        ].freeze
+
+        Error = Class.new(StandardError)
+        Suspended = Class.new(Error)
+
+        def self.default_path
+          File.join(Hive::Paths.state_home, FILENAME)
+        end
+
+        def initialize(path: self.class.default_path, logger: nil, clock: -> { Time.now })
+          @path = path ? File.expand_path(path) : nil
+          @logger = logger
+          @clock = clock
+          @suspend_writes = false
+          @suspend_reason = nil
+          clean_orphaned_tmp_files!
+        end
+
+        attr_reader :suspend_writes, :suspend_reason
+
+        def suspended?
+          @suspend_writes
+        end
+
+        # @return [Hash, nil] record or nil
+        def get(project:, task_key:, stage:, reason:)
+          all = load_all
+          all[key_for(project, task_key, stage, reason)]
+        end
+
+        def find_by_recovery_id(recovery_id)
+          id = recovery_id.to_s
+          return nil if id.empty?
+
+          matches = load_all.values.select do |record|
+            record.is_a?(Hash) && record["recovery_id"].to_s == id
+          end
+          raise Error, "duplicate_recovery_id" if matches.length > 1
+
+          matches.first
+        end
+
+        def upsert!(project:, task_key:, stage:, reason:, **fields)
+          raise Suspended, @suspend_reason || "writes_suspended" if @suspend_writes
+          raise Suspended, "no_path" unless @path
+
+          with_lock do
+            data = read_document
+            records = data.fetch("records")
+            k = key_for(project, task_key, stage, reason)
+            existing = records[k].is_a?(Hash) ? records[k] : default_record(project, task_key, stage, reason)
+            merged = existing.merge(stringify_fields(fields))
+            merged["project"] = project.to_s
+            merged["task_key"] = task_key.to_s
+            merged["stage"] = stage.to_s
+            merged["reason"] = reason.to_s
+            merged["updated_at"] = @clock.call.utc.iso8601(6)
+            records[k] = merged
+            write_document!(data.merge("records" => records, "schema_version" => SCHEMA_VERSION))
+            merged
+          end
+        end
+
+        def mark_dispatched!(project:, task_key:, stage:, reason:, fingerprint:, recovery_id:)
+          raise Suspended, @suspend_reason || "writes_suspended" if @suspend_writes
+
+          with_lock do
+            data = read_document
+            records = data.fetch("records")
+            k = key_for(project, task_key, stage, reason)
+            rec = records[k]
+            raise Error, "missing_retry_record" unless rec.is_a?(Hash)
+            existing_recovery_id = rec["recovery_id"].to_s
+            unless !existing_recovery_id.empty? && existing_recovery_id == recovery_id.to_s
+              raise Error, "recovery_id_mismatch"
+            end
+            if rec["phase"].to_s == "retry_dispatched"
+              return rec
+            end
+            unless %w[marker_cleared retry_queued].include?(rec["phase"].to_s)
+              raise Error, "invalid_dispatch_phase:#{rec['phase']}"
+            end
+            attempts = rec["attempts_dispatched"].to_i + 1
+            raise Error, "attempt_budget_exhausted" if attempts > Policy::MAX_ATTEMPTS
+            rec = rec.merge(
+              "attempts_dispatched" => attempts,
+              "last_attempted_fingerprint" => fingerprint.to_s,
+              "phase" => "retry_dispatched",
+              "recovery_id" => recovery_id.to_s,
+              "updated_at" => @clock.call.utc.iso8601(6)
+            )
+            if attempts >= Policy::MAX_ATTEMPTS
+              # Exhaustion is finalized when the next same-reason failure is
+              # observed; here we only count the dispatch.
+            end
+            records[k] = rec
+            write_document!(data.merge("records" => records, "schema_version" => SCHEMA_VERSION))
+            rec
+          end
+        end
+
+        def mark_exhausted!(project:, task_key:, stage:, reason:)
+          upsert!(project: project, task_key: task_key, stage: stage, reason: reason,
+                  phase: "exhausted")
+        end
+
+        def rearm_manual!(project:, task_key:, stage:, reason:)
+          raise Suspended, @suspend_reason || "writes_suspended" if @suspend_writes
+
+          with_lock do
+            data = read_document
+            records = data.fetch("records")
+            k = key_for(project, task_key, stage, reason)
+            records[k] = default_record(project, task_key, stage, reason).merge(
+              "phase" => "candidate",
+              "manual_epoch_at" => @clock.call.utc.iso8601(6),
+              "updated_at" => @clock.call.utc.iso8601(6)
+            )
+            write_document!(data.merge("records" => records, "schema_version" => SCHEMA_VERSION))
+            records[k]
+          end
+        end
+
+        def load_all
+          return {} if @suspend_writes
+          return {} unless @path && File.exist?(@path)
+
+          read_document.fetch("records")
+        rescue Suspended
+          {}
+        end
+
+        def key_for(project, task_key, stage, reason)
+          [ project, task_key, stage, reason ].map { |p| p.to_s.gsub("|", "_") }.join("|")
+        end
+
+        def self.task_key(task_id: nil, slug: nil)
+          id = task_id.to_s.strip
+          return id unless id.empty?
+
+          slug.to_s
+        end
+
+        private
+
+        def default_record(project, task_key, stage, reason)
+          {
+            "project" => project.to_s,
+            "task_key" => task_key.to_s,
+            "stage" => stage.to_s,
+            "reason" => reason.to_s,
+            "phase" => "candidate",
+            "attempts_dispatched" => 0,
+            "last_attempted_fingerprint" => nil,
+            "second_candidate_fingerprint" => nil,
+            "second_candidate_first_seen_at" => nil,
+            "eligible_at" => nil,
+            "last_probe_at" => nil,
+            "last_probe_fingerprint" => nil,
+            "last_probe_healthy" => nil,
+            "last_probe_rationale" => nil,
+            "last_probe_signal" => nil,
+            "marker_id" => nil,
+            "marker_signature" => nil,
+            "recovery_id" => nil,
+            "recovery_class" => nil,
+            "slug" => nil,
+            "folder" => nil,
+            "clear_argv" => nil,
+            "rerun_argv" => nil,
+            "clear_request_id" => nil,
+            "retry_request_id" => nil,
+            "last_negative_signature" => nil,
+            "last_negative_at" => nil,
+            "updated_at" => @clock.call.utc.iso8601(6)
+          }
+        end
+
+        def stringify_fields(fields)
+          fields.each_with_object({}) do |(k, v), acc|
+            key = k.to_s
+            acc[key] = case v
+            when Time then v.utc.iso8601(6)
+            when Symbol then v.to_s
+            else v
+            end
+          end
+        end
+
+        def read_document
+          return { "schema_version" => SCHEMA_VERSION, "records" => {} } unless @path && File.exist?(@path)
+
+          parsed = JSON.parse(File.read(@path))
+          suspend_and_raise!("root_not_hash") unless parsed.is_a?(Hash)
+
+          version = parsed["schema_version"]
+          suspend_and_raise!("missing_schema_version") unless version.is_a?(Integer)
+          if version > SCHEMA_VERSION
+            @suspend_writes = true
+            @suspend_reason = "newer_schema"
+            raise Suspended, "newer_schema"
+          end
+          records = parsed["records"]
+          suspend_and_raise!("records_not_hash") unless records.is_a?(Hash)
+          suspend_and_raise!("record_not_hash") unless records.values.all? { |record| record.is_a?(Hash) }
+          parsed
+        rescue JSON::ParserError, TypeError, SystemCallError, IOError => e
+          suspend_and_raise!("corrupt:#{e.class}")
+        end
+
+        def write_document!(doc)
+          raise Suspended, "no_path" unless @path
+
+          dir = File.dirname(@path)
+          FileUtils.mkdir_p(dir)
+          tmp = "#{@path}.tmp.#{Process.pid}.#{Thread.current.object_id}"
+          File.open(tmp, File::WRONLY | File::CREAT | File::TRUNC, 0o644) do |f|
+            f.write(JSON.pretty_generate(doc))
+            f.flush
+            f.fsync
+          end
+          File.rename(tmp, @path)
+          fsync_dir(dir)
+        rescue SystemCallError, IOError => e
+          suspend_and_raise!("write_error:#{e.class}")
+        ensure
+          FileUtils.rm_f(tmp) if defined?(tmp) && tmp && File.exist?(tmp)
+        end
+
+        def fsync_dir(dir)
+          d = Dir.open(dir)
+          d.fsync if d.respond_to?(:fsync)
+        rescue StandardError
+          nil
+        ensure
+          d&.close
+        end
+
+        def with_lock
+          return yield unless @path
+
+          lock_path = "#{@path}.lock"
+          FileUtils.mkdir_p(File.dirname(lock_path))
+          File.open(lock_path, File::RDWR | File::CREAT, 0o644) do |lf|
+            lf.flock(File::LOCK_EX)
+            yield
+          end
+        rescue SystemCallError => e
+          @logger&.event(:daemon_auto_retry_lock_error,
+                         path: @path, error_class: e.class.name, message: e.message)
+          raise Suspended, "lock_error:#{e.class}"
+        end
+
+        def suspend!(reason)
+          @suspend_writes = true
+          @suspend_reason = reason
+          @logger&.event(:daemon_auto_retry_state_suspended, path: @path, reason: reason)
+          {}
+        end
+
+        def suspend_and_raise!(reason)
+          suspend!(reason)
+          raise Suspended, reason
+        end
+
+        def clean_orphaned_tmp_files!
+          return unless @path
+
+          dir = File.dirname(@path)
+          return unless File.directory?(dir)
+
+          Dir.glob(File.join(dir, "#{File.basename(@path)}.tmp.*")).each do |tmp|
+            next unless File.file?(tmp)
+            next if (Time.now - File.mtime(tmp)) < STALE_TMP_SEC
+
+            FileUtils.rm_f(tmp)
+          rescue StandardError
+            nil
+          end
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/dispatch_request_queue.rb b/lib/hive/daemon/dispatch_request_queue.rb
index 00d7aacc..9e52a030 100644
--- a/lib/hive/daemon/dispatch_request_queue.rb
+++ b/lib/hive/daemon/dispatch_request_queue.rb
@@ -2,6 +2,7 @@ require "json"
 require "fileutils"
 require "securerandom"
 require "time"
+require "digest"
 require "hive/paths"
 require "hive/daemon/queue_directory"
 
@@ -30,7 +31,7 @@ module Hive
 
       Request = Struct.new(
         :request_id, :created_at, :project, :slug, :argv, :requestor,
-        :chat_id, :update_id, :trigger, :path,
+        :chat_id, :update_id, :trigger, :path, :recovery_id, :recovery_step,
         keyword_init: true
       )
 
@@ -48,14 +49,35 @@ module Hive
         SecureRandom.hex(8)
       end
 
+      ALLOWED_REQUESTORS = %w[bot healer auto_retry].freeze
+
       def write_request!(project:, slug:, argv:, requestor: "bot", chat_id: nil,
                          update_id: nil, trigger: nil, request_id: generate_request_id,
-                         state_home: Hive::Paths.state_home, now: Time.now)
+                         state_home: Hive::Paths.state_home, now: Time.now,
+                         recovery_id: nil, recovery_step: nil)
         unless valid_argv?(argv)
           raise ArgumentError, "argv #{argv.inspect} is not allowlisted for dispatch requests"
         end
         raise ArgumentError, "project is required for dispatch requests" if project.to_s.empty?
         raise ArgumentError, "slug is required for dispatch requests" if slug.to_s.empty?
+        unless ALLOWED_REQUESTORS.include?(requestor.to_s)
+          raise ArgumentError, "requestor #{requestor.inspect} is not allowlisted"
+        end
+
+        unless recovery_id.to_s.empty?
+          existing = metadata(request_id, state_home: state_home)
+          if existing
+            coherent = existing[:project].to_s == project.to_s &&
+                       existing[:slug].to_s == slug.to_s &&
+                       existing[:requestor].to_s == requestor.to_s &&
+                       existing[:recovery_id].to_s == recovery_id.to_s &&
+                       existing[:recovery_step].to_s == recovery_step.to_s &&
+                       Array(existing[:argv]) == Array(argv)
+            return request_id.to_s if coherent
+
+            raise ArgumentError, "request_id #{request_id.inspect} collides with different recovery metadata"
+          end
+        end
 
         created_at = now.utc
         payload = {
@@ -71,6 +93,10 @@ module Hive
           "update_id" => update_id,
           "trigger" => trigger.to_s
         }
+        payload["recovery_id"] = recovery_id.to_s if recovery_id && !recovery_id.to_s.empty?
+        if recovery_step && !recovery_step.to_s.empty?
+          payload["recovery_step"] = recovery_step.to_s
+        end
 
         dir = directory(state_home: state_home)
         filename = filename_for(created_at: created_at, request_id: request_id)
@@ -82,6 +108,7 @@ module Hive
           f.fsync
         end
         File.rename(tmp_path, final_path)
+        fsync_directory(dir)
         request_id.to_s
       ensure
         FileUtils.rm_f(tmp_path) if defined?(tmp_path) && tmp_path && File.exist?(tmp_path)
@@ -272,7 +299,9 @@ module Hive
           return {
             chat_id: data["chat_id"], update_id: data["update_id"],
             project: data["project"], slug: data["slug"],
-            requestor: data["requestor"]
+            requestor: data["requestor"],
+            recovery_id: data["recovery_id"], recovery_step: data["recovery_step"],
+            argv: data["argv"]
           }
         end
         nil
@@ -280,7 +309,12 @@ module Hive
         nil
       end
 
-      def write_sequence!(request_id, remaining_argvs:, state_home: Hive::Paths.state_home)
+      def request_exists?(request_id, state_home: Hive::Paths.state_home)
+        !metadata(request_id, state_home: state_home).nil?
+      end
+
+      def write_sequence!(request_id, remaining_argvs:, state_home: Hive::Paths.state_home,
+                          recovery_id: nil)
         remaining = Array(remaining_argvs)
         return discard_sequence(request_id, state_home: state_home) if remaining.empty?
 
@@ -290,12 +324,15 @@ module Hive
 
         path = sequence_path(directory(state_home: state_home), request_id)
         tmp_path = "#{path}.tmp.#{Process.pid}.#{Thread.current.object_id}"
+        payload = { "request_id" => request_id.to_s, "remaining_argvs" => remaining }
+        payload["recovery_id"] = recovery_id.to_s if recovery_id && !recovery_id.to_s.empty?
         File.open(tmp_path, File::WRONLY | File::CREAT | File::TRUNC, 0o600) do |f|
-          f.write(JSON.generate("request_id" => request_id.to_s, "remaining_argvs" => remaining))
+          f.write(JSON.generate(payload))
           f.flush
           f.fsync
         end
         File.rename(tmp_path, path)
+        fsync_directory(File.dirname(path))
         true
       ensure
         FileUtils.rm_f(tmp_path) if defined?(tmp_path) && tmp_path && File.exist?(tmp_path)
@@ -314,28 +351,41 @@ module Hive
 
       def promote_sequence(request_id, project:, slug:, requestor: "bot", chat_id: nil,
                            update_id: nil, trigger: "sequence_continuation",
-                           state_home: Hive::Paths.state_home, now: Time.now)
+                           state_home: Hive::Paths.state_home, now: Time.now,
+                           recovery_id: nil)
         dir = directory(state_home: state_home)
         path = sequence_path(dir, request_id)
-        sequence = read_sequence(path)
+        sequence_doc = read_sequence_doc(path)
+        sequence = Array(sequence_doc["remaining_argvs"])
+        recovery_id = recovery_id || sequence_doc["recovery_id"]
         return nil if sequence.empty?
 
         next_argv = sequence.shift
+        next_request_id = if recovery_id && !recovery_id.to_s.empty?
+          ::Digest::SHA256.hexdigest("#{recovery_id}:rerun")[0, 16]
+        else
+          generate_request_id
+        end
         next_request_id = write_request!(
           project: project, slug: slug, argv: next_argv, requestor: requestor,
           chat_id: chat_id, update_id: update_id, trigger: trigger,
-          state_home: state_home, now: now
+          state_home: state_home, now: now,
+          recovery_id: recovery_id,
+          recovery_step: recovery_id ? "rerun" : nil,
+          request_id: next_request_id
         )
         if sequence.empty?
           FileUtils.rm_f(path)
         else
-          write_sequence!(next_request_id, remaining_argvs: sequence, state_home: state_home)
+          write_sequence!(next_request_id, remaining_argvs: sequence, state_home: state_home,
+                          recovery_id: recovery_id)
           FileUtils.rm_f(path)
         end
         Request.new(
           request_id: next_request_id, created_at: now.utc, project: project.to_s,
           slug: slug.to_s, argv: next_argv, requestor: requestor.to_s,
-          chat_id: chat_id, update_id: update_id, trigger: trigger.to_s, path: nil
+          chat_id: chat_id, update_id: update_id, trigger: trigger.to_s, path: nil,
+          recovery_id: recovery_id, recovery_step: recovery_id ? "rerun" : nil
         )
       end
 
@@ -407,14 +457,20 @@ module Hive
       end
 
       def read_sequence(path)
+        Array(read_sequence_doc(path)["remaining_argvs"])
+      end
+
+      def read_sequence_doc(path)
         data = JSON.parse(File.read(path))
-        remaining = data.is_a?(Hash) ? data["remaining_argvs"] : nil
-        return [] unless remaining.is_a?(Array)
-        return [] unless remaining.all? { |argv| valid_argv?(argv) }
+        return {} unless data.is_a?(Hash)
+
+        remaining = data["remaining_argvs"]
+        return {} unless remaining.is_a?(Array)
+        return {} unless remaining.all? { |argv| valid_argv?(argv) }
 
-        remaining
+        data
       rescue Errno::ENOENT, JSON::ParserError, IOError
-        []
+        {}
       end
 
       # Persist directory entries (renames/unlinks) so they survive an
@@ -508,7 +564,9 @@ module Hive
             chat_id: data["chat_id"],
             update_id: data["update_id"],
             trigger: data["trigger"].to_s,
-            path: path
+            path: path,
+            recovery_id: data["recovery_id"],
+            recovery_step: data["recovery_step"]
           )
         end
 
diff --git a/lib/hive/daemon/dispatcher.rb b/lib/hive/daemon/dispatcher.rb
index 1f272c69..ade67742 100644
--- a/lib/hive/daemon/dispatcher.rb
+++ b/lib/hive/daemon/dispatcher.rb
@@ -21,8 +21,11 @@ require "hive/daemon/digest_scheduler"
 require "hive/daemon/answer_digest_scheduler"
 require "hive/daemon/patrol_scheduler"
 require "hive/daemon/pr_merge_watcher"
+require "hive/daemon/auto_retry/coordinator"
+require "hive/daemon/auto_retry/state"
 require "hive/lock"
 require "hive/paths"
+require "hive/runtime_identity"
 require "hive/update_check"
 require "hive/update_check/state"
 require "hive/install_channel"
@@ -159,6 +162,22 @@ module Hive
         # see the next warning the next time it goes red, but we don't
         # actively re-emit on every tick. Issue #95.
         @legacy_layout_logged = {}
+        # Health-gated auto-retry coordinator (v1). Own subsystem; not part
+        # of StaleAgentHealer. Default-on via daemon.auto_retry.enabled.
+        # Constructed after @enabled_cache / @legacy_layout_projects so the
+        # closures and tick-time legacy pointer stay valid.
+        auto_retry_cfg = @daemon_cfg["auto_retry"].is_a?(Hash) ? @daemon_cfg["auto_retry"] : {}
+        @auto_retry_enabled = auto_retry_cfg.fetch("enabled", true) != false
+        @auto_retry = AutoRetry::Coordinator.new(
+          logger: @logger,
+          controller: @controller,
+          state: AutoRetry::State.new(logger: @logger),
+          enabled: @auto_retry_enabled,
+          dry_run: @dry_run,
+          config_for_project: ->(name) { load_project_config_for_auto_retry(name) },
+          project_enabled: ->(name) { project_enabled?(name) },
+          legacy_projects: @legacy_layout_projects
+        )
         # Test-injectable state homes for the dispatch-request and
         # dispatch-result queues. Production passes nil so both resolve
         # `Hive::Paths.state_home`; unit tests inject a sandbox. The result
@@ -314,6 +333,19 @@ module Hive
                         last_error: drop[:last_error])
         end
 
+        # 3a. Health-gated auto-retry coordinator. Runs AFTER merge-watcher
+        # (finalize merge recovery keeps precedence) and BEFORE dispatch-
+        # request processing so a newly queued clear can pass normal queue
+        # gates in the same tick.
+        begin
+          @auto_retry.instance_variable_set(:@legacy_projects, @legacy_layout_projects)
+          @auto_retry.tick(result.rows, now: now)
+        rescue StandardError => e
+          @logger.event(:fatal,
+                        message: "auto_retry coordinator raised: #{e.class}: #{e.message}",
+                        keeping_previous: true)
+        end
+
         # 3b. Dispatch-request queue (plan 2026-05-28-002). Process
         # bot-written request files BEFORE the per-row scan so a slug
         # whose request just spawned is already in-flight in the
@@ -477,12 +509,90 @@ module Hive
       # as a cheap drift signal — if the on-disk file's digest no longer
       # matches what we captured at startup, the loaded code is stale.
       # Returns nil on any failure; a nil baseline disables drift checks
-      # so a transient read failure never re-execs.
+      # so a transient read failure never re-execs. Factored through
+      # RuntimeIdentity so re-exec detection and Claude health validation
+      # cannot disagree.
       def compute_code_fingerprint
-        path = Hive::Schemas.method(:schema_path).source_location.first
-        ::Digest::SHA256.file(path).hexdigest
+        Hive::RuntimeIdentity.code_fingerprint
+      end
+
+      def load_project_config_for_auto_retry(project_name)
+        entry = Hive::Config.find_project(project_name)
+        return {} unless entry
+
+        Hive::Config.load(entry["path"])
       rescue StandardError
-        nil
+        {}
+      end
+
+      def auto_retry_rerun_request?(req)
+        argv = Array(req.argv)
+        return false if argv[1].to_s == "markers"
+
+        step = req.respond_to?(:recovery_step) ? req.recovery_step.to_s : ""
+        step == "rerun"
+      end
+
+      def note_auto_retry_dispatch!(req)
+        recovery_id = req.respond_to?(:recovery_id) ? req.recovery_id : nil
+        recovery_id = recovery_id.to_s
+        return false if recovery_id.empty?
+
+        state = @auto_retry.instance_variable_get(:@state)
+        match = state.find_by_recovery_id(recovery_id)
+        return false unless coherent_auto_retry_match?(req, match, expected_step: "rerun")
+
+        @auto_retry.note_retry_dispatched!(
+          recovery_id: recovery_id,
+          project: req.project,
+          slug: req.slug,
+          stage: match["stage"],
+          reason: match["reason"]
+        )
+      rescue Hive::Daemon::AutoRetry::State::Error => e
+        @logger.event(:auto_retry_state_error, message: e.message,
+                                               recovery_id: recovery_id)
+        false
+      end
+
+      def auto_retry_request_authorized?(req)
+        return false unless @auto_retry_enabled
+
+        recovery_id = req.respond_to?(:recovery_id) ? req.recovery_id.to_s : ""
+        step = req.respond_to?(:recovery_step) ? req.recovery_step.to_s : ""
+        return false if recovery_id.empty? || !%w[clear rerun].include?(step)
+
+        state = @auto_retry.instance_variable_get(:@state)
+        match = state.find_by_recovery_id(recovery_id)
+        return false unless coherent_auto_retry_match?(req, match, expected_step: step)
+
+        # marker_cleared is accepted for clear only to close the write-ahead
+        # crash window: the ledger may advance immediately before the marker
+        # rewrite, and reconciliation must be able to repeat that same clear.
+        allowed_phases = step == "clear" ? %w[clear_queued marker_cleared] : %w[marker_cleared retry_queued retry_dispatched]
+        allowed_phases.include?(match["phase"].to_s)
+      rescue Hive::Daemon::AutoRetry::State::Error => e
+        @logger.event(:auto_retry_state_error, message: e.message,
+                                               recovery_id: recovery_id)
+        false
+      end
+
+      def coherent_auto_retry_match?(req, match, expected_step:)
+        return false unless match.is_a?(Hash)
+        return false if match["stage"].to_s.empty? || match["reason"].to_s.empty?
+        return false if match["recovery_id"].to_s.empty?
+        return false unless match["recovery_id"].to_s == req.recovery_id.to_s
+        return false unless match["project"].to_s == req.project.to_s
+        return false unless match["slug"].to_s == req.slug.to_s
+
+        return false unless req.recovery_step.to_s == expected_step.to_s
+
+        request_field = expected_step.to_s == "clear" ? "clear_request_id" : "retry_request_id"
+        argv_field = expected_step.to_s == "clear" ? "clear_argv" : "rerun_argv"
+        return false if match[request_field].to_s.empty? || Array(match[argv_field]).empty?
+        return false unless match[request_field].to_s == req.request_id.to_s
+
+        Array(match[argv_field]) == Array(req.argv)
       end
 
       # True iff a baseline fingerprint exists, a fresh fingerprint can
@@ -1315,6 +1425,12 @@ module Hive
           return
         end
 
+        if req.requestor.to_s == "auto_retry" && !auto_retry_request_authorized?(req)
+          reason = @auto_retry_enabled ? "auto_retry_authorization_failed" : "auto_retry_disabled"
+          reject_request(req, reason: reason)
+          return
+        end
+
         if Hive::Daemon::DispatchRequestQueue.expired?(req, now: now)
           expire_request(req)
           return
@@ -1366,7 +1482,7 @@ module Hive
       # Build a command string from the validated argv and spawn it
       # through the same `dispatch_command` path auto-advance uses.
       #
-      # C3: immediately after the spawn we CLAIM the request file —
+      # C3: immediately before the spawn we CLAIM the request file —
       # rename `<id>.json` → `<id>.json.claimed` and stamp the child's
       # pid + process_start_time. The claimed file is invisible to
       # `pending`, so a later tick never re-observes (or re-dispatches)
@@ -1374,9 +1490,24 @@ module Hive
       # `recover_dispatch_claims` cleans up at next start instead of
       # re-running the work. The claimed file is unlinked on reap.
       def dispatch_request!(req, now:)
+        preclaim_dispatch_request(req, now: now)
+
+        # Auto-retry attempt accounting: count only when the same-stage
+        # rerun is authorized for dispatch (not on marker clear).
+        if req.requestor.to_s == "auto_retry" && auto_retry_rerun_request?(req)
+          unless note_auto_retry_dispatch!(req)
+            @logger.event(:dispatch_request_blocked,
+                          request_id: req.request_id, project: req.project,
+                          slug: req.slug, reason: "auto_retry_state_write_failed")
+            Hive::Daemon::DispatchRequestQueue.release_claim(
+              req.request_id, state_home: dispatch_request_state_home
+            )
+            return
+          end
+        end
+
         command = Shellwords.join(req.argv)
         state_file_path = resolve_request_state_file_path(req)
-        preclaim_dispatch_request(req, now: now)
         pid = dispatch_command(
           command,
           project: req.project, slug: req.slug,
@@ -1842,6 +1973,10 @@ module Hive
           logger: @logger,
           dry_run: @dry_run
         )
+        # Toggle auto-retry kill switch without reconstructing durable state.
+        auto_retry_cfg = @daemon_cfg["auto_retry"].is_a?(Hash) ? @daemon_cfg["auto_retry"] : {}
+        @auto_retry_enabled = auto_retry_cfg.fetch("enabled", true) != false
+        @auto_retry&.reconfigure!(enabled: @auto_retry_enabled)
         @enabled_cache.clear
         @logger.event(:config_reloaded)
       rescue Hive::ConfigError => e
diff --git a/lib/hive/daemon/logger.rb b/lib/hive/daemon/logger.rb
index 6af59dc9..04c8d97c 100644
--- a/lib/hive/daemon/logger.rb
+++ b/lib/hive/daemon/logger.rb
@@ -76,6 +76,17 @@ module Hive
         digest_state_unreadable
         answer_digest_failure_backoff
         answer_digest_state_unreadable
+        auto_retry_decision
+        auto_retry_error
+        auto_retry_state_error
+        auto_retry_state_suspended
+        auto_retry_queue_error
+        auto_retry_sequence_error
+        auto_retry_audit_error
+        auto_retry_reconcile
+        daemon_auto_retry_newer_schema_suspended
+        daemon_auto_retry_state_suspended
+        daemon_auto_retry_lock_error
         fatal
       ].freeze
 
diff --git a/lib/hive/daemon/status_consumer.rb b/lib/hive/daemon/status_consumer.rb
index b483ad0a..2af9aec3 100644
--- a/lib/hive/daemon/status_consumer.rb
+++ b/lib/hive/daemon/status_consumer.rb
@@ -19,7 +19,7 @@ module Hive
       Row = Struct.new(:project, :slug, :stage, :workflow, :marker, :marker_attrs, :folder, :state_file,
                        :state_file_mtime, :action, :suggested_command, :claude_pid_alive,
                        :live_task_lock, :diagnostic, :depends_on, :blocked_by,
-                       :dependency_stage, :blocked,
+                       :dependency_stage, :blocked, :id, :worktree_path,
                        keyword_init: true)
       # Aggregated per-project legacy-layout signal lifted out of each
       # project payload's `legacy_stage_dirs` array. The dispatcher uses
@@ -196,7 +196,9 @@ module Hive
               depends_on: task["depends_on"],
               blocked_by: task["blocked_by"],
               dependency_stage: task["dependency_stage"],
-              blocked: task["blocked"] == true
+              blocked: task["blocked"] == true,
+              id: task["id"],
+              worktree_path: task["worktree_path"]
             )
           end
         end
